#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string.h>
#include "config.h"
#include "compat.h"
#include "global.h"
#define _column_c_
#include "column.h"

ColF	*Columns = NULL_ColF;

ColF *
colf_get(tname,cname,exact)
char	*tname;
char	*cname;
int	exact;
{
	ColF	*cfp, *ret;

	cfp = Columns;
	ret = NULL_ColF;

	while(cfp != NULL_ColF){
		if(strcmp(cname,cfp->name) == 0){
			if(strcmp(tname,cfp->table) == 0){
				ret = cfp;
				break; /*exact match*/
			}
			if(!exact && cfp->table[0] == '*')
				ret = cfp;
		}
		cfp = cfp->next;
	}

	return(ret);
}

void
colf_copy(to,from)
ColF *to;
ColF *from;
{
	if(from == NULL_ColF || to == NULL_ColF)
		return;

	if(from->tsize)
		strcpy(to->title,from->title);

	to->display = from->display;
	to->size = from->size;
	to->just = from->just;
	to->tsize = from->tsize;
	to->tjust = from->tjust;
	to->numf = from->numf;
	to->intf = from->intf;
	to->realf = from->realf;
	to->wrap = from->wrap;
	to->cc = 0;
	to->len = 0;
}

ColF *
colf_new(tname,cname)
char *tname;
char *cname;
{
	ColF *cfp;

	if((cfp = (ColF *)calloc(1,sizeof(ColF))) == NULL){
		Err(ErrIalloc,NULL_char);
		return(NULL_ColF);
	}
	strcpy(cfp->table,tname);
	strcpy(cfp->name,cname);
	cfp->display = TRUE;
	cfp->title[0] = '\0';
	cfp->tsize = 0;
	cfp->size = 0;
	cfp->just = J_NONE;
	cfp->tjust = J_NONE;
	cfp->numf = NULL_char;
	cfp->intf = NULL_char;
	cfp->realf = NULL_char;
	cfp->wrap = WRAP_NONE;
	return(cfp);
}

void
colf_free(cfp)
ColF *cfp;
{

	free_char(cfp->numf);
	free_char(cfp->intf);
	free_char(cfp->realf);

	free((FREETYPE *)cfp);

}


