#include <string.h>
#include <msql.h>
#include "config.h"
#include "compat.h"
#include "global.h"
#include "column.h"

static char	*fillbuf(); /* char *bp, int len, char c */
static char	*fillfld(); /* char *bp,*s,int blen,slen,just */
static int	wrap_word();
static int	wrap_line();
static void	cvt_spaces();

/*#define DEBUG		/* */


int
doquery(q)
char	*q;
{
	register char	*cp,*bp,*op,*ep,*rp,*np;
	int		n,nc,nr,nrp,blen,len,num,wrap,begin;
	long		intval;
	double		realval;
	m_result	*result;
	m_row		row;
	m_field		*f;
	char		*separ, *head, *buf, *endbar, *rowsep,
			*nullsep, *intf, *realf,
			nbuf[MAX_NUM_WIDTH + MAX_NUM_WIDTH];
	ColF		*cf, *cfp, *cfp1;


	if(!Connected){
		if(Initial){
			if(connect_db() == RET_ERR)
				return(RET_ERR);
		} else {
			Err(ErrUnotconnected,NULL_char);
			return(RET_ERR);
		}
	}

	if (msqlQuery(SQLsock,q) < 0){
		Err(ErrServer,msqlErrMsg);
		return(RET_ERR);
	}

	result = msqlStoreResult();
	if (!result){
		Out("\nQuery OK.\n\n");
		return(RET_OK);
	}

	
	if((nr = msqlNumRows(result)) == 0){
		Out("\n0 records matched.\n\n");
		msqlFreeResult(result);
		return(RET_OK);
	}

	nc = msqlNumFields(result);

	if((cf = (ColF *)calloc(nc,sizeof(ColF))) == NULL){
		msqlFreeResult(result);
		Err(ErrIalloc,NULL_char);
		return(RET_MEM_ERR);
	}

	if((buf = (char *)malloc(def_page_width +2)) == NULL){
		Err(ErrIalloc,"(query_rec_buffer)");
		msqlFreeResult(result);
		return(RET_MEM_ERR);
	}

	if((endbar = (char *)malloc(def_page_width +2)) == NULL){
		Err(ErrIalloc,"(query_endbar)");
		msqlFreeResult(result);
		return(RET_MEM_ERR);
	}

	separ = NULL_char;
	head = NULL_char;
	if(def_heading){
		if((head = (char *)malloc(def_page_width +2)) == NULL)
			Err(ErrIalloc,"(query_header)");
		if((separ = (char *)malloc(def_page_width +2)) == NULL)
			Err(ErrIalloc,"(query_separator)");
	}
	nullsep = NULL_char;
	if(def_rowsep){
		if((rowsep = (char *)malloc(def_page_width +2)) == NULL)
			Err(ErrIalloc,"(query_rowsep)");
		if(def_colsep){
			if((nullsep = (char *)malloc(def_page_width +2)) == NULL)
			Err(ErrIalloc,"(query_nullsep)");
		}
	} else
		rowsep = NULL_char;

	/* Collect information on columns and print headers ****************/


	cfp = cf;
	intf = NULL_char;
	realf = NULL_char;

	bp = head;
	blen = 0;
	cp = separ;
	ep = endbar;
	rp = rowsep;
	np = nullsep;

	begin = 1;

	if(def_colsep){
		if(head != NULL_char){
			bp = fillbuf(bp,def_margin_left,' ');
			*bp++ = def_colsep;
			blen = def_margin_left + 1;
			if(separ != NULL_char){
				cp = fillbuf(cp,def_margin_left,' ');
				*cp++ = def_colsep;
			}
		}
		ep = fillbuf(ep,def_margin_left,' ');
		*ep++ = '+';
		if(rowsep != NULL_char){
			rp = fillbuf(rp,def_margin_left,' ');
			*rp++ = def_colsep;
			if(nullsep != NULL_char){
				np = fillbuf(np,def_margin_left,' ');
				*np++ = def_colsep;
			}
		}
	} else {
		if(head != NULL_char){
			bp = fillbuf(bp,def_margin_left,' ');
			blen = def_margin_left;
			if(separ != NULL_char)
				cp = fillbuf(cp,def_margin_left,' ');
		}
		ep = fillbuf(ep,def_margin_left,' ');
		if(rowsep != NULL_char)
			rp = fillbuf(rp,def_margin_left,' ');
	}


	while((f = msqlFetchField(result))){
#ifdef DEBUG
		printf("tab %s, col %s\n",f->table,f->name);
#endif
		if((cfp1 = colf_get(f->table,f->name,0)) != NULL_ColF){
			colf_copy(cfp,cfp1);
			if(cfp->display == FALSE){
				cfp++;
				continue;
			}
		} else
			cfp->display = TRUE;

		if(cfp->tsize == 0){
			strcpy(cfp->title,f->name);
			cfp->tsize = strlen(f->name);
		}

		if(cfp->tjust == J_NONE)
			cfp->tjust = J_LEFT;

		cfp->type = f->type;

		switch(f->type){

		case INT_TYPE:
			if(cfp->numf == NULL_char){
			  if(intf == NULL_char){
				  /* make new default format */
			    if((intf = makenumformat(def_numformat,NUMF_INT)) == NULL_char)
				goto query_end;
			  }
			} else if((cfp->intf = makenumformat(cfp->numf,NUMF_INT)) == NULL_char)
				goto query_end;

			if(cfp->size == 0)
				cfp->size = max(cfp->tsize,def_numwidth);
			if(cfp->just == J_NONE)
				cfp->just = J_RIGHT;
			break;

		case REAL_TYPE:
			if(cfp->numf == NULL_char){
			  if(realf == NULL_char){
				  /* make new default format */
			    if((realf = makenumformat( def_numformat, NUMF_FLOAT)) == NULL_char)
				goto query_end;
			  }
			} else if((cfp->realf = makenumformat( cfp->numf, NUMF_FLOAT)) == NULL_char)
				goto query_end;

			if(cfp->size == 0)
				cfp->size = max(cfp->tsize,def_numwidth);
			if(cfp->just == J_NONE)
				cfp->just = J_RIGHT;
			break;

		case CHAR_TYPE:
			if(cfp->size == 0)
				cfp->size = max(cfp->tsize,f->length);

			if(cfp->just == J_NONE)
				cfp->just = J_LEFT;

			if(cfp->wrap == WRAP_NONE)
				cfp->wrap = def_wrap;

			break;
		}

		blen += cfp->size;
		if(def_colsep)
			blen += 3;
		else if(!begin)
			blen++;

		if(blen > def_page_width){
			Err(ErrUouttoolarge,NULL_char);
			goto query_end;
		}

		if(def_colsep){
		    if(head != NULL_char){
			*bp++ = ' ';
			bp = fillfld(bp, cfp->title, cfp->size,
					cfp->tsize, cfp->tjust,0);
			*bp++ = ' ';
			*bp++ = def_colsep;
			if(separ != NULL_char){
			    cp = fillbuf(cp,cfp->size+2,def_hline_char);
			    *cp++ = def_colsep;
		   	}
		    }
		    ep = fillbuf(ep,cfp->size+2,def_fline_char);
		    *ep++ = '+';
		    if(rowsep != NULL_char){
			rp = fillbuf(rp,cfp->size+2,def_rowsep);
			*rp++ = def_colsep;
			if(nullsep != NULL_char){
			    np = fillbuf(np,cfp->size+2,' ');
			    *np++ = def_colsep;
			}
		    }
		} else { /* no colsep */
		    if(head != NULL_char){
			if(!begin)
			    *bp++ = ' ';
			bp = fillfld(bp, cfp->title, cfp->size,
					cfp->tsize, cfp->tjust,0);
			if(separ != NULL_char){
			    if(!begin)
				*cp++ = ' ';
			    cp = fillbuf(cp,cfp->size,def_hline_char);
			}
		    }
		    if(!begin)
			*ep++ = def_fline_char;
		    ep = fillbuf(ep,cfp->size,def_fline_char);
		    if(rowsep != NULL_char){
			if(!begin)
			    *rp++ = ' ';
			rp = fillbuf(rp,cfp->size,def_rowsep);
		    }
		}

		begin = 0;
		cfp++;
	}
	*ep = '\0';
	if(head != NULL_char){
		*bp = '\0';
		if(separ != NULL_char)
			*cp = '\0';
		ReportOut(NULL_char,head,separ,endbar,NULL_char,NULL_char);
	}
	if(rowsep != NULL_char){
		*rp = '\0';
		if(nullsep != NULL_char)
			*np = '\0';
	}

	/* Print the returned data ***************************************/

	msqlFieldSeek(result,0);

	nrp = 0;
	while ((row = msqlFetchRow(result))){
		if(def_maxrows && nrp >= def_maxrows)
			break;
		nrp++;

		for(n = 0, cfp = cf; n < nc; n++,cfp++){
			/* reset */
			cfp->len = 0;
			cfp->cc = 0;
		}
		ReportOut(NULL_char,head,separ,endbar,rowsep,nullsep);
row_begin:
		wrap = 0;
		bp = buf;

		begin = 1;
		if(def_colsep){
			bp = fillbuf(bp,def_margin_left,' ');
			*bp++ = def_colsep;
		} else {
			bp = fillbuf(bp,def_margin_left,' ');
		}
		for(n = 0, cfp = cf; n < nc; n++,cfp++){
		   if(cfp->display == FALSE)
			continue;
		   op = row[n];
		   num = 0;
		   len = 0;
		   switch(cfp->type){
		   case INT_TYPE:
			if(*op == '\0'){
				cfp->len = -1;
				break;
			}
			if(cfp->len == -1)
				break;

			intval = atol(op);
			if(cfp->numf == NULL_char)
				sprintf(nbuf,intf,intval);
			else
				sprintf(nbuf,cfp->intf,intval);
			num = 1;
			op = nbuf;
			SKIP_SPACES(op);
			len = strlen(op);
			cfp->len = -1;
			break;
		   case REAL_TYPE:
			if(*op == '\0'){
				cfp->len = -1;
				break;
			}
			if(cfp->len == -1)
				break;
			sscanf(op,"%lf",&realval);
			if(cfp->numf == NULL_char)
				sprintf(nbuf,realf,realval);
			else
				sprintf(nbuf,cfp->realf,realval);
			num = 1;
			op = nbuf;
			SKIP_SPACES(op);
			len = strlen(op);
			cfp->len = -1;
			break;
		   case CHAR_TYPE:

			if(cfp->cc){
				op += cfp->cc; /* move pointer*/
			} else {
				if(cfp->len != -1)
					cfp->len = strlen(op);
			}

			if(cfp->len < 1){
				len = 0;
				break;
			}

			len = cfp->len - cfp->cc;

			/* skip spaces */
			while(*op == ' ' || *op == '\t' 
			   || *op == '\n' || *op == '\r'){
				op++; len--; cfp->cc++;
			}

			if(cfp->wrap == WRAP_TRUNC){
				cvt_spaces(op,cfp->size);
				cfp->len = -1;
				break;
			}

			if(cfp->size < len){
				if(cfp->wrap == WRAP_WORD)
					len = wrap_word(op,cfp->size);
				else if(cfp->wrap == WRAP_LINE)
					len = wrap_line(op,cfp->size);
				else {
					cvt_spaces(op,cfp->size);
					len = cfp->size;
				}
				cfp->cc += len;
				wrap = 1;
			} else {
				cvt_spaces(op,cfp->size);
				cfp->len = -1;
			}
		   }
		   if(def_colsep){
			*bp++ = ' ';
		        bp = fillfld(bp,op,cfp->size,len,cfp->just,num);
			*bp++ = ' ';
			*bp++ = def_colsep;
		   }else{
			if(!begin)
				*bp++ = ' ';
			bp = fillfld(bp,op,cfp->size,len,cfp->just,num);
		   }
		   begin = 0;
		}

		*bp = '\0';
		ReportOut(buf,head,separ,endbar,NULL_char,NULL_char);
		msqlFieldSeek(result,0);
		if(wrap)
			goto row_begin;

	}
	if(def_maxrows)
		sprintf(buf,"%d records matched, %d displayed.\n\n",nr,nrp);
	else
		sprintf(buf,"%d records matched.\n\n",nr);
	ReportEnd(endbar,buf);

query_end:

	free_char(endbar);
	free_char(separ);
	free_char(head);
	free_char(intf);
	free_char(realf);
	free_char(rowsep);
	free_char(nullsep);

	for(n = 0, cfp = cf; n < nc; n++,cfp++){
		if(cfp->intf != NULL_char)
			free_char(cfp->intf);
		if(cfp->realf != NULL_char)
			free_char(cfp->realf);
	}

	free((FREETYPE *)cf);
	free_char(buf);
	msqlFreeResult(result);
	return(RET_OK);
}

static void
cvt_spaces(bp,size)
register char *bp;
register int size;
{
	register int i = 0;

	while(i < size && *bp != '\0'){
		if(*bp == '\t' || *bp == '\n' || *bp == '\r')
			*bp = ' ';
		i++; bp++;
	}
}

static int
wrap_word(bp,max)
register char *bp;
register int max;
{
	register int i,last;

	i = 0;
	last = max;

	while(i < max && *bp != '\0'){
		if(*bp == ' ')
			last = i;
		else if(*bp == '\t' || *bp == '\n' || *bp == '\r'){
			*bp = ' ';
			last = i;
		}
		i++;
		bp++;
	}

	return(last);
}

static int
wrap_line(bp,max)
register char *bp;
register int max;
{
	register int i,last;

	i = 0;
	last = max;

	while(i < max && *bp != '\0'){
		if(*bp == ' ')
			last = i;
		else if(*bp == '\t'){
			*bp = ' ';
			last = i;
		} else if(*bp == '\n' || *bp == '\r'){
			*bp = ' ';
			last = i;
			break;
		}
		i++;
		bp++;
	}

	return(last);
}

static char *
fillbuf(bp,len,c)
char		*bp;
register int	len;
register char	c;
{
	while(len-- > 0)
		*bp++ = c;

	return(bp);
}


static char *
fillfld(bp,s,blen,slen,just,num)
register char	*bp;		/*buffre pointer*/
register char	*s;		/* source string*/
register int	blen;		/*buffer length*/
register int	slen;		/*string length*/
int	just;			/*justify*/
int	num;			/* is numeric */
{
	int len,len1;

	if(num && slen > blen) /* overflow */
		return(fillbuf(bp,blen,DEF_OVERF_CHAR));

	if(slen < 1)
		return(fillbuf(bp,blen,' '));

	if(slen >= blen) { /* truncate string */
		while(blen-- > 0 && *s != '\0')
			*bp++ = *s++;
		return(bp);
	}

	len = blen - slen;

	if(just == J_RIGHT){		/* right justify */
		bp = fillbuf(bp,len,' ');
		while(slen-- > 0 && *s != '\0')
			*bp++ = *s++;
		return(bp);
	} else if(just == J_CENTR){	/* centre justify */
		len  = len / 2;
		len1 = blen - (slen + len);

		bp = fillbuf(bp,len,' ');
		while(slen-- > 0 && *s != '\0')
			*bp++ = *s++;
		bp = fillbuf(bp,len1,' ');
		return(bp);
	}

	while(slen-- > 0 && *s != '\0')	/* left justify */
		*bp++ = *s++;
	bp = fillbuf(bp,len,' ');

	return(bp);
}
